type high
type low
type ('a,'b) iref

type ('a,'b,'c) ist

val alloc: 'a -> ('pc,'pc,('pc,'a) iref) ist

val read: ('l,'a) iref -> (high,'l,'a) ist
val write: ('l,'a) iref -> 'a -> ('l,low,unit) ist

(* --Some input data-- *)
val hasLoan: (high,bool) iref
val principal: (high,int) iref (* the amount of the loan *)
val rate: (low,float) iref
val months: (low,int) iref

(* --Output locations-- *)
val monthlyPayment: (high,float) iref
val nLoans: (low,int) iref

(* -- Some pure functions -- *)
val calc: int -> int -> float -> float
val calcloan: int -> float -> float
val i2f: int -> float


(*val savings: (high,float) iref
*)val rate: (low,float) iref
val lastpayment: (low,float) iref
val addinterests: int -> int -> int
val addinterests2: float -> (high,low,float) ist
val update_savings: float -> ('a,low,unit) ist
val current_date: unit -> float

