type high = High
type low
type ('a,'b) iref

type ('a,'b,'c) ist
type file

(* rotateCount and filename are read from the configuration file *)
val rotateCount: unit -> (high,high,int) ist
val filename: unit -> (high,high,string) ist

(* getFile requires the file name to be of a  security level;
   to simplify we require this level to be Low 
val getFile: (unit -> (high,'l,string) ist) -> 'l -> (high,'l,unit) ist
*) 
val getFile: (unit -> (low,low,string) ist) -> (low,low,unit) ist
val renameTo: (unit -> ('pc2,'l2,file) ist) -> (unit -> ('pc2,'l2,file) ist) -> ('pc2,'l2,unit) ist

val null: int -> bool
val decr: int -> int
val concat: string -> int -> string


val alloc: 'a -> (low,low,(low,'a) iref) ist

val read: ('l,'a) iref -> (high,'l,'a) ist
val write: ('l,'a) iref -> 'a -> ('l,low,unit) ist


